---
- name: Backup Panos FW to a Server
  hosts: FW_Group
  gather_facts: False

  tasks:

    - name: Export configuration
      paloaltonetworks.panos.panos_export:
        provider: '{{ provider }}'
        category: 'configuration'
        filename: 'running-config.xml'
      delegate_to: localhost

    - name: create time stamp for play
      set_fact:
        datetime: "{{ lookup('pipe','date +%Y-%m-%d-%H-%M') }}"
      delegate_to: local_vm
      delegate_facts: true
      run_once: true

    - name: Create a directory if it does not exist
      ansible.builtin.file:
        path: /root/backups/palo/
        state: directory
      delegate_to: local_vm
      become: true
      run_once: true

    - name: modify configuration name
      copy:
        src: 'running-config.xml'
        dest: "{{ inventory_hostname }}-running-config.xml"
      become: true
      delegate_to: localhost

    - name: save configuration to backup server
      copy:
        src: "{{ inventory_hostname }}-running-config.xml"
        dest: "/root/backups/palo/{{hostvars['local_vm'].datetime}}/"
      become: true
      delegate_to: local_vm

      

    